<?php
/**
 * @package     corejoomla.administrator
 * @subpackage  plg_cjlib
 *
 * @copyright   Copyright (C) 2009 - 2016 corejoomla.com. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
defined('_JEXEC') or die;

require_once 'framework.php';
require_once JPATH_COMPONENT.DS.'controller.php';

CJLib::import('corejoomla.framework.core');

$app = JFactory::getApplication();
$config = CJLib::get_cjconfig();

$task = $app->input->getCmd('task', '');
$secret = $app->input->getCmd('secret', null);
$component = 'com_cjlib';

if($task == 'process' && !empty($secret) && (strcmp($config['cron_secret'], $secret) == 0))
{
	$emails = (int)$config['cron_emails'];
	$delay = (int)$config['cron_delay'];
	$sent = CJFunctions::send_messages_from_queue($emails, $delay, false);
	
	if(!empty($sent))
	{
		echo json_encode($sent);
	}
} 
else if($task = 'socialcounts')
{
	require_once CJLIB_PATH.'/lib/misc/socialcounts.php';
	$url = base64_decode(JFactory::getApplication()->input->getString('url'));
	
	if( !SocialCount::REQUIRE_LOCAL_URL || SocialCount::isLocalUrl( $url ) ) 
	{
		try 
		{
			$social = new SocialCount( $url );
			$social->addNetwork(new Twitter());
			$social->addNetwork(new Facebook());
			$social->addNetwork(new GooglePlus());
			// $social->addNetwork(new ShareThis());
	
			echo $social->toJSON();
		} 
		catch(Exception $e) 
		{
			echo '{"error": "' . $e->getMessage() . '"}';
		}
	} 
	else 
	{
		echo '{"error": "URL not authorized."}';
	}
}

jexit();